## ros-kinetic-rospilot 1.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(rospilot)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS geometry_msgs sensor_msgs std_msgs message_generation roslint roscpp)
find_package(PkgConfig REQUIRED)
find_package(OpenCV 3 REQUIRED)
pkg_check_modules(libgphoto2 REQUIRED libgphoto2)
pkg_check_modules(libavcodec REQUIRED libavcodec)
pkg_check_modules(libavformat REQUIRED libavformat)
pkg_check_modules(libavutil REQUIRED libavutil)
pkg_check_modules(libswscale REQUIRED libswscale)
pkg_check_modules(libnl-3.0 REQUIRED libnl-3.0)
pkg_check_modules(libnl-genl-3.0 REQUIRED libnl-genl-3.0)
pkg_check_modules(libmicrohttpd REQUIRED libmicrohttpd)

catkin_python_setup()

file(GLOB python_source_files nodes/*.py)
roslint_python(${python_source_files})
roslint_add_test()

## System dependencies are found with CMake's conventions
# find_package(Boost REQUIRED COMPONENTS system)


## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
# catkin_python_setup()

 include(CheckCXXCompilerFlag)
 CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
 CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
 if(COMPILER_SUPPORTS_CXX11)
     set(CMAKE_CXX_FLAGS "-std=c++11")
 elseif(COMPILER_SUPPORTS_CXX0X)
     set(CMAKE_CXX_FLAGS "-std=c++0x")
 else()
     message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
 endif()

 find_library(LIBJPEG_TURBO_PATH NAMES "libturbojpeg.so.0" "libturbojpeg.so.1")
#######################################
## Declare ROS messages and services ##
#######################################

## Generate messages in the 'msg' folder
add_message_files(
  FILES
  Attitude.msg
  BasicStatus.msg
  Battery.msg
  RCState.msg
  GPSRaw.msg
  Resolution.msg
  Resolutions.msg
  Waypoint.msg
  Waypoints.msg
  VisionTarget.msg
  VisionTargets.msg
  IMURaw.msg
)

## Generate services in the 'srv' folder
add_service_files(
  FILES
  SetBasicMode.srv
  SetWaypoints.srv
  CaptureImage.srv
)

## Generate added messages and services with any dependencies listed here
generate_messages(
    DEPENDENCIES
    std_msgs
    geometry_msgs
    sensor_msgs
)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
#  INCLUDE_DIRS include
#  LIBRARIES rospilot
#  CATKIN_DEPENDS geometry_msgs sensor_msgs std_msgs
  CATKIN_DEPENDS message_runtime
#  DEPENDS system_lib
)


###############################
## Generate Javascript files ##
###############################

configure_file(
    share/web_assets/package.json
    ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/nodejs_deps/package.json
    COPYONLY)
configure_file(
    share/web_assets/package-lock.json
    ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/nodejs_deps/package-lock.json
    COPYONLY)

add_custom_command(OUTPUT DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/nodejs_deps/node_modules
    COMMAND npm install
    DEPENDS ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/nodejs_deps/package.json
            ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/nodejs_deps/package-lock.json
    WORKING_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/nodejs_deps
    COMMENT "Building Javascript files")

add_custom_target(javascript_assets ALL
    DEPENDS DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/nodejs_deps/node_modules)
###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(include src/cpp
    ${OpenCV_INCLUDE_DIRS}
    ${catkin_INCLUDE_DIRS}
    ${libnl-3.0_INCLUDE_DIRS}
    ${libnl-genl-3.0_INCLUDE_DIRS}
    ${libmicrohttpd_INCLUDE_DIRS}
    ${libavcodec_INCLUDE_DIRS}
    ${libavformat_INCLUDE_DIRS}
    ${libavutil_INCLUDE_DIRS}
    ${libswscale_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS})

## Declare a cpp library
# add_library(rospilot
#   src/${PROJECT_NAME}/rospilot.cpp
# )

## Declare a cpp executable
# add_executable(rospilot_node src/rospilot_node.cpp)

## Add cmake target dependencies of the executable/library
## as an example, message headers may need to be generated before nodes
# add_dependencies(rospilot_node rospilot_generate_messages_cpp)

## Specify libraries to link a library or executable target against
# target_link_libraries(rospilot_node
#   ${catkin_LIBRARIES}
# )

add_executable(choose_wifi_device
    src/cpp/choose_wifi_device.cpp)
target_link_libraries(choose_wifi_device 
    ${libnl-3.0_LIBRARIES}
    ${libnl-genl-3.0_LIBRARIES}
    ${catkin_LIBRARIES})

add_executable(camera_node
    nodes/camera.cpp
    src/cpp/usb_camera.cpp
    src/cpp/ptp.cpp
    src/cpp/background_image_sink.cpp
    src/cpp/jpeg_decoder.cpp
    src/cpp/h264_server.cpp
    src/cpp/people_detector.cpp
    src/cpp/resizer.cpp
    src/cpp/software_h264_encoder.cpp
    src/cpp/mfc_encoder.cpp
    src/cpp/third_party/usb_cam.cpp
    src/cpp/third_party/mfc/func_dev.c
    src/cpp/third_party/mfc/io_dev.c
    src/cpp/third_party/mfc/v4l_dev.c
    src/cpp/third_party/mfc/mfc.c
    src/cpp/video_recorder.cpp)
target_link_libraries(camera_node 
    ${OpenCV_LIBRARIES}
    ${LIBJPEG_TURBO_PATH}
    ${libgphoto2_LIBRARIES}
    ${libavcodec_LIBRARIES}
    ${libmicrohttpd_LIBRARIES}
    ${libavutil_LIBRARIES}
    ${libavformat_LIBRARIES}
    ${libswscale_LIBRARIES}
    ${catkin_LIBRARIES})
add_dependencies(camera_node rospilot_gencpp)

add_executable(jpeg_benchmark
    scripts/jpeg_benchmark.cpp
    src/cpp/jpeg_decoder.cpp
    src/cpp/resizer.cpp)
target_link_libraries(jpeg_benchmark 
    ${LIBJPEG_TURBO_PATH}
    ${libavcodec_LIBRARIES}
    ${libavutil_LIBRARIES}
    ${libavformat_LIBRARIES}
    ${libswscale_LIBRARIES}
    ${catkin_LIBRARIES})

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
file(GLOB nodes nodes/*)
install(PROGRAMS
  ${nodes}
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

file(GLOB scripts scripts/*.sh)
install(PROGRAMS
  ${scripts}
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark executables and/or libraries for installation
install(TARGETS camera_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(TARGETS choose_wifi_device 
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)
## Mark cpp header files for installation
# install(DIRECTORY include/${PROJECT_NAME}/
#   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
#   FILES_MATCHING PATTERN "*.h"
#   PATTERN ".svn" EXCLUDE
# )

install(FILES
  launch/rospilot.launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(DIRECTORY
  share/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/share
  PATTERN "mapnik-style/data" EXCLUDE
)
install(DIRECTORY
  ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/nodejs_deps/node_modules/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/nodejs_deps/node_modules
)

#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
# catkin_add_gtest(${PROJECT_NAME}-test test/test_rospilot.cpp)
# if(TARGET ${PROJECT_NAME}-test)
#   target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME})
# endif()

## Add folders to be run by python nosetests
# catkin_add_nosetests(test)

=== debian/changelog ===
ros-kinetic-rospilot (1.4.1-0xenial) xenial; urgency=high

  * Switch to HTTPS for openstreetmap.org
  * Workaround camera drivers that don't set keyframe flag
  * Add support for reading raw YUV from camera
  * Refactor pixel format handling
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Sat, 10 Mar 2018 08:00:00 -0000

ros-kinetic-rospilot (1.4.0-0xenial) xenial; urgency=high

  * Add "follow me" mode
  * Add support for direct h264 capture from camera
  * Improve automatic camera selection
  * Add vibration data to display
    Also includes accelerometer clipping counts
  * Add support for battery voltage monitoring
  * Enable pre-release tests
  * Add Travis integration
  * Refactor handling of NPM dependencies
  * Add native Systemd service
  * Set dns search domain for better compatibility
  * Update wifi setup script with proper dnsmasq dependency
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Sun, 19 Nov 2017 08:00:00 -0000

ros-kinetic-rospilot (1.3.8-0xenial) xenial; urgency=high

  * Remove dependency on nodejs-legacy
    Also remove usage of vendored npm version
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Wed, 13 Sep 2017 07:00:00 -0000

ros-kinetic-rospilot (1.3.7-0xenial) xenial; urgency=high

  * Update for newest NPM
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Sat, 10 Jun 2017 07:00:00 -0000

ros-kinetic-rospilot (1.3.6-0xenial) xenial; urgency=high

  * Add support for Pixhawk2.1
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Mon, 29 May 2017 07:00:00 -0000

ros-kinetic-rospilot (1.3.5-0xenial) xenial; urgency=high

  * Add missing include needed on Debian
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Sun, 12 Mar 2017 08:00:00 -0000

ros-kinetic-rospilot (1.3.4-0xenial) xenial; urgency=high

  * Rescale PTS properly
  * Fix usage of deprecated API
  * Fix usage of invalid iterator
  * Add more logging to camera node
  * Fix data structure corruption due to race
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Wed, 08 Mar 2017 08:00:00 -0000

ros-kinetic-rospilot (1.3.3-0xenial) xenial; urgency=high

  * Fix build on Debian
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Wed, 24 Aug 2016 07:00:00 -0000

ros-kinetic-rospilot (1.3.2-0xenial) xenial; urgency=high

  * Support building on Debian
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Wed, 24 Aug 2016 07:00:00 -0000

ros-kinetic-rospilot (1.3.1-0xenial) xenial; urgency=high

  * Fix build on Wily
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Sun, 21 Aug 2016 07:00:00 -0000

ros-kinetic-rospilot (1.3.0-0xenial) xenial; urgency=high

  * Initialize source frame data structure
  * Update init script to Kinetic
  * Set CherryPy to production instead of manually configuring it
  * Use npm for build
  * Use more canonical license string
  * Fix scoping in set waypoint callback
  * Improve mavlink wait logic to be interruptable
  * Fix retry logic for serial mavlink
  * Migrate to Angular 2.0
  * Add timeout to waypoint fetching
    Previously, if a message was lost waypoints would no longer be fetched
    and new ones could not be set
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Sat, 20 Aug 2016 07:00:00 -0000

ros-kinetic-rospilot (1.2.0-0xenial) xenial; urgency=high

  * Add people detector using OpenCV
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Sat, 14 May 2016 07:00:00 -0000

ros-kinetic-rospilot (1.1.1-0xenial) xenial; urgency=high

  * Copy files to /etc as part of setup script instead of package install
  * Fix warnings and installation of mapnik files
  * Add missing python-serial dependency
  * Cleanup linking of libturbojpeg
    This should fix compiling on other platforms like x86_32
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Sun, 31 Jan 2016 08:00:00 -0000

ros-kinetic-rospilot (1.1.0-0xenial) xenial; urgency=high

  * Auto-detect camera device path
  * Improve video streaming FPS ~2x
  * Add support for hardware h264 acceleration on Odroid XU4
  * Add FPS counter to camera page
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Mon, 18 Jan 2016 08:00:00 -0000

ros-kinetic-rospilot (1.0.3-0xenial) xenial; urgency=high

  * Fix race freeing background image sink resources
  * Fix bad free on older versions of libav
  * Improve formatting of first_time_setup.sh output
  * Update readme
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Sun, 23 Aug 2015 07:00:00 -0000

ros-kinetic-rospilot (1.0.2-0xenial) xenial; urgency=high

  * Remove unnecessary imports
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Wed, 12 Aug 2015 07:00:00 -0000

ros-kinetic-rospilot (1.0.1-0xenial) xenial; urgency=high

  * Fix compilation error on vivid and utopic
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Sun, 09 Aug 2015 07:00:00 -0000

ros-kinetic-rospilot (1.0.0-0xenial) xenial; urgency=high

  * Switch to H264 codec for streaming and recording
  * Fix a variety of minor bugs
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Sat, 08 Aug 2015 07:00:00 -0000

ros-kinetic-rospilot (0.2.5-0xenial) xenial; urgency=high

  * Tune MFC encoder parameters
  * Contributors: Christopher Berner

 -- Christopher Berner <christopherberner@gmail.com>  Sun, 31 May 2015 07:00:00 -0000

ros-kinetic-rospilot (0.2.4-0xenial) xenial; urgency=high



=== debian/control ===
Source: ros-kinetic-rospilot
Section: misc
Priority: extra
Maintainer: Christopher Berner <christopherberner@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libavcodec-dev, libavformat-dev, libavutil-dev, libgphoto2-dev, libjpeg-turbo8-dev, libmicrohttpd-dev, libnl-3-dev, libnl-genl-3-dev, libswscale-dev, libturbojpeg, npm, ros-kinetic-catkin, ros-kinetic-geometry-msgs, ros-kinetic-message-generation, ros-kinetic-opencv3, ros-kinetic-roscpp, ros-kinetic-roslint, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-std-srvs
Homepage: 
Standards-Version: 3.9.2

Package: ros-kinetic-rospilot
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, curl, dnsmasq, gdal-bin, hostapd, libcurl4-openssl-dev, libnl-3-200, libnl-genl-3-200, mapnik-utils, osm2pgsql, postgresql-9.5-postgis-2.2, postgresql-contrib-9.5, postgresql-server-dev-9.5, python-cherrypy3, python-colorama, python-mapnik, python-psutil, python-serial, ros-kinetic-geometry-msgs, ros-kinetic-mavlink, ros-kinetic-message-runtime, ros-kinetic-rosbash, ros-kinetic-rosbridge-suite, ros-kinetic-roslaunch, ros-kinetic-rospy, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-std-srvs, ros-kinetic-vision-opencv, tilestache, unzip
Description: rospilot

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-rospilot//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
